*:********************************************************************
*:
*: Procedure file :bear.prg
*:
*: (c) Piva, BEAR v.42 on 25.04.2003 09:38
*:********************************************************************
#DEFINE BEAR_VERSION	"v.45"
#DEFINE BEA_BAK 	"BEA_BAK.BEA"
#DEFINE prg_step	0.05
#define CR			chr(13)
#DEFINE CRLF		chr(13)+Chr(10)
#define WORD_BREAK	" ()[]"+chr(9)
#define NOTE_MARK	"*:"

#DEFINE c_Message	.T.
#define CONTENTS	.F.

* Using FoxTools.FLL for internal editor access

PARAMETER m.PRGFILE
IF not _WINDOWS
	WAIT WIndow NoWait "Windows only"
	RETURN .F.
ENDIF
IF empty(Wontop())
	RETURN .F.
ENDIF

IF not "FOXTOOLS.FLL" $ Set('libr')
	SET libr to FoxTools additive
ENDIF
PRIVATE all

_VISUAL=atc("VISUAL",VERS())>0

wh=_WONTOP()

IF wh < 1
	RETURN .F.
ENDIF
DECLARE aa[25], PR[1]
PR=""
m.PrCount=0

*=_EDGetEnv(wh,@aa)
*m.PRGFILE=aa[1]

=_EDGetEnv(wh,@aa)
m.PRGFILE=aa[1]
m.Kind=aa[25]
m.Size=aa[2]


If m.Kind < 1
	=msgbox("Invalid Edit Window","",48)
	Return .F.
EndIf

m.old=select()
SELECT 0

#IF not c_Message
	=Progress(0," "+chr(13)+m.PRGFILE ,"Bear")
#ENDIF

ib=0
ID=0
_P=""
w=""
w2=""
w3=""

clsn=""
clsb=""
cmnt=.f.

prv=0

_CLIPTEXT=""

=_EdUndoOn(wh,.T.)		&&  UNDO
m.CurPos=_EdGetPos(wh)	&&  
=_EdSetPos(wh,0)		&&   
m.Start=0				&&   
m.End=0					&&   

IF _VISUAL
	_screen.MousePointer=11
ENDIF

DO while .t.
	m.End=_EdSkipLin(wh, m.Start, 1)	&&   -   
	IF m.End=m.Start					&&    -  
		EXIT
	ENDIF
	s=alltrim(_EdGetStr(wh, m.Start, m.End))	&& 
	IF at(CR,s) > 0						&&  CR
		s=substr(s,1,at(CR,s)-1)
	ENDIF
	IF m.End/m.Size >= prv				&&  
		prv=m.End/size+prg_step
		#IF c_Message
			SET message to m.PRGFILE+" "+tran(m.End/m.Size*100,"999% completed.")
		#ELSE
			=Progress(m.End/size)
		#ENDIF
	ENDIF
	DO while left(alltrim(s),1)=chr(9)	&&   TAB'
		s=iif(len(s)>1,substr(s,2),"")
	ENDDO
	w=upper(wordnum(s,1,WORD_BREAK))	&&  
	w2=wordnum(s,2,WORD_BREAK)	&&  
	l=len(w)
	l2=len(w2)
	
	IF not cmnt and left(s,2)=NOTE_MARK
		m.Start=m.End
		LOOP
	ENDIF
	
	id=Iif(id<0,0,id)
	*? id,ib,s
	
	DO case
	CASE ATC(w,'PROCEDURE')=1 and l>=4
		=ProcHeader()
	CASE ATC(w,'FUNCTION')=1 and l>=4
		=FuncHeader()
	CASE ATC(w,'DEFINE')=1 and l>=4
		DO case
		CASE atc(w2,'CLASS')=1 and l2>=4
			clsn=wordnum(s,3)
			=ClassHeader()
		ENDCASE
	CASE ATC(w,'PROTECTED')=1 and l>=4 and ATC(w2,'PROCEDURE')=1 and l2 >= 4
		=ProcHeader()
	CASE ATC(w,'PROTECTED')=1 and l>=4 and ATC(w2,'FUNCTION')=1 and l2 >= 4
		=FuncHeader()
	CASE ATC(w,'HIDDEN')=1 and l>=4 and ATC(w2,'PROCEDURE')=1 and l2 >= 4
		=ProcHeader()
	CASE ATC(w,'HIDDEN')=1 and l>=4 and ATC(w2,'FUNCTION')=1 and l2 >= 4
		=FuncHeader()
	ENDCASE
	
	IF l >=4 and ;
			(ATC(w,'ENDIF')=1 or ;
			ATC(w,'#ENDIF')=1 or ;
			ATC(w,'ENDDO')=1 or ;
			ATC(w,'ENDCASE')=1 or ;
			ATC(w,'ENDSCAN')=1 or ;
			ATC(w,'ENDFOR')=1 or ;
			ATC(w,'NEXT')=1 or ;
			ATC(w,'ENDWITH')=1 or ;
			ATC(w,'ENDPRINTJOB')=1 or ;
			ATC(w,'ENDTRY')=1)
			
		
		*			 ATC(w,'ENDFUNCTION')=1)
		*			 or ATC(w,'ENDPROCEDURE')=1 )
		
		* Decrement indention
		ID=id-1
		
	ENDIF
	
	IF l >=4 and ATC(w,'ENDDEFINE')=1
		clsn=""
		* Decrement Indent behind
		ib=0
		id=0
	ENDIF
	
	IF l >=4 and ;
			(ATC(w,'ELSE')=1 or ;
			ATC(w,'CASE')=1 or ;
			ATC(w,'#ELSE')=1 or ;
			ATC(w,'#ELIF')=1 or ;
			ATC(w,'OTHERWISE')=1 or ;
			ATC(w,'CATCH')=1 or ;
			ATC(w,'FINALLY')=1 or ;
			ATC(w,'THROW')=1) 
	
		ID=id-1
	ENDIF
	
	IF (ib+id+iif(cmnt,1,0)) > 0
		_P=repl(chr(9),ib+id+iif(cmnt,1,0))
	ELSE
		_P=""
	ENDIF

	=Put(_P+s)
	
	IF right(s,1)=';'
		cmnt=.t.
	ELSE
		IF cmnt
			cmnt=.f.
		ENDIF
	ENDIF
	
	IF l >=4 and ;
			(ATC(w,'ELSE')=1 or ;
			ATC(w,'CASE')=1 or ;
			ATC(w,'#ELSE')=1 or ;
			ATC(w,'#ELIF')=1 or ;
			ATC(w,'OTHERWISE')=1 or ;
			ATC(w,'CATCH')=1 or ;
			ATC(w,'FINALLY')=1 or ;
			ATC(w,'THROW')=1) 
		
		ID=id+1
	ENDIF
	
	DO case
	CASE ATC(w,'PROCEDURE')=1 and l>=4
		id=0
	CASE ATC(w,'FUNCTION')=1 and l>=4
		id=0
	CASE ATC(w,'DO')=1 and l=2
		DO case
		CASE atc(w2,'WHILE')=1 and l2>=4
			ID=id+1
		CASE atc(w2,'CASE')=1 and l2=4
			ID=id+1
		ENDCASE
	CASE ATC(w,'FOR')=1 and l=3
		ID=id+1
	CASE ATC(w,'IF')=1 and l=2
		ID=id+1
	CASE ATC(w,'#IF')=1 and l=3
		ID=id+1
	CASE ATC(w,'DEFINE')=1 and l>=4
		DO case
		CASE atc(w2,'CLASS')=1 and l2>=4
			w2=wordnum(s,3)
			ib=ib+1
		ENDCASE
	CASE ATC(w,'WITH')=1 and l=4
		ID=id+1
	CASE ATC(w,'SCAN')=1 and l=4
		ID=id+1
	CASE ATC(w,'TEXT')=1 and l=4
		ID=id+1
	CASE ATC(w,'PRINTJOB')=1 and l>=4
		ID=id+1
	CASE ATC(w,'TRY')=1 and l=3
		ID=id+1
	ENDCASE
	m.Start=m.End
ENDDO

#IF c_Message
	SET message to m.PRGFILE+" "+tran(100,"999% completed.")
#ELSE
	=Progress(1)
#ENDIF

=Put("*: End of "+JustFName(m.PRGFILE))

=fileheader()

=_EdSelect(wh,0,m.Size)
=_EdDelete(wh)
=_EdPaste(wh)

=_EdSetPos(wh,m.CurPos)
=_EdStoPos(wh,m.CurPos,.T.)

=_EdUndoOn(wh,.f.)

SELECT (m.old)

#IF c_Message
	SET message to
#ELSE
	=Progress()
#ENDIF

IF _VISUAL
	_screen.MousePointer=0
ENDIF


*:********************************************************************
*:
*: Procedure : fileheader
*:
*:********************************************************************
PROCEDURE fileheader
PRIVATE i, v
v=""
v=v+'*:'+repl('*',68)+CRLF
If m.Kind=1
	v=v+'*:'+CRLF
	v=v+'*: Procedure file :'+m.PRGFILE+CRLF
EndIf
v=v+'*:'+CRLF

IF m.PrCount > 0
	v=v+"*: Contents :"+CRLF
	FOR i=1 to m.PrCount
		if PR[i]='Class  '
*			v=v+'*: '+CRLF
		endif
		v=v+"*: "+Chr(9)+Chr(9)+PR[i]+CRLF
	NEXT
	v=v+'*:'+CRLF
ENDIF
v=v+'*: (c) Piva, BEAR '+BEAR_VERSION+' on '+DtoC(Date())+' '+substr(time(),1,5)+CRLF
v=v+'*:'+repl('*',68)+CRLF

_CLIPTEXT=v+_CLIPTEXT

*:********************************************************************
*:
*: Procedure : ProcHeader
*:
*:********************************************************************
PROCEDURE ProcHeader
if atc(w,'PROTECTED')=1 or atc(w,'HIDDEN')=1
	w2=wordnum(s,3,WORD_BREAK)
endif

If CONTENTS
	m.PrCount=m.PrCount+1
	IF m.PrCount > ALEN(PR,1)
		DECLARE PR[m.PrCount]
	ENDIF
	PR[m.PrCount]="Procedure "+clsn+iif(not empty(clsn),".","")+w2
EndIf 

IF not empty(clsn)
	=classmethodheader()
ELSE
	=Put(repl(chr(9),ib+id)+'*:'+repl('*',68))
	=Put(repl(chr(9),ib+id)+'*:')
	=Put(repl(chr(9),ib+id)+'*: Procedure : '+w2)
	=Put(repl(chr(9),ib+id)+'*:')
	=Put(repl(chr(9),ib+id)+'*:'+repl('*',68))
ENDIF

*:********************************************************************
*:
*: Procedure : FuncHeader
*:
*:********************************************************************
PROCEDURE FuncHeader
if atc(w,'PROTECTED')=1 or atc(w,'HIDDEN')=1
	w2=wordnum(s,3,WORD_BREAK)
	*	PR[m.PrCount]="Function  "+clsn+iif(not empty(clsn),".","")+w2+' '+upper(w)
	*else
endif

If CONTENTS
	m.PrCount=m.PrCount+1
	IF m.PrCount > ALEN(PR,1)
		DECLARE PR[m.PrCount]
	ENDIF
	PR[m.PrCount]="Function  "+clsn+iif(not empty(clsn),".","")+w2
EndIf


IF not empty(clsn)
	=classmethodheader()
ELSE
	=Put(repl(chr(9),ib+id)+'*:'+repl('*',68))
	=Put(repl(chr(9),ib+id)+'*:')
	=Put(repl(chr(9),ib+id)+'*: Function : '+w2)
	=Put(repl(chr(9),ib+id)+'*:')
	=Put(repl(chr(9),ib+id)+'*:'+repl('*',68))
ENDIF

*:********************************************************************
*:
*: Procedure : ClassHeader
*:
*:********************************************************************
PROCEDURE ClassHeader
PRIVATE _s, k
_s=s
k=atc("AS ",_s)
IF k=0
	k=atc("AS"+chr(9), _s)
ENDIF
IF k > 0
	clsb=wordnum(substr(_s,k+3), 1)
ELSE
	clsb=""
ENDIF

m.PrCount=m.PrCount+Iif(CONTENTS,2,1)
IF m.PrCount > ALEN(PR,1)
	DECLARE PR[m.PrCount]
ENDIF
If CONTENTS
	PR[m.PrCount-1]=""
ENDIF
PR[m.PrCount]="Class     "+clsn+" AS "+clsb

=Put(repl(chr(9),ib)+'*:'+repl('*',68))
=Put(repl(chr(9),ib)+'*:')
=Put(repl(chr(9),ib)+'*:    Class : '+clsn+iif(not empty( clsb )," based on "+clsb,""))
=Put(repl(chr(9),ib)+'*:')
=Put(repl(chr(9),ib)+'*:'+repl('*',68))

*:********************************************************************
*:
*: Procedure : ClassMethodHeader
*:
*:********************************************************************
PROCEDURE ClassMethodHeader
private m.w_
m.w_=""

if atc(w,'PROTECTED')=1 or atc(w,'HIDDEN')=1
	w2=wordnum(s,3,WORD_BREAK)
	PR[m.PrCount]=PR[m.PrCount]+" "+w
	m.w_=w
endif

=Put(repl(chr(9),ib+id)+'*:'+repl('*',68))
=Put(repl(chr(9),ib+id)+'*:')
=Put(repl(chr(9),ib+id)+'*: Method : '+w2+' of class '+clsn+iif(!empty(m.w_)," - "+m.w_,""))
=Put(repl(chr(9),ib+id)+'*:')
=Put(repl(chr(9),ib+id)+'*:'+repl('*',68))

*:********************************************************************
*:
*: Procedure : MSG
*:
*:********************************************************************
PROCEDURE MSG
PARAMETER m.msgtext
IF _VISUAL
	messagebox(m.msgtext,16,'Bea')
ELSE
	=MSGBOX(m.msgtext,"Bea",16)
ENDIF
RETURN .F.


*:********************************************************************
*:
*: Procedure : Put
*:
*:********************************************************************
PROCEDURE Put
PARAMETER m.What
_CLIPTEXT=_CLIPTEXT+m.What+CRLF


*: End of bear.prg
